/**//*   歌词 感谢lrc123.com的歌词下载  OSD-lyrics的鼠标穿透 */
#include "encoding.h"
gchar keyword[2000];

gvoid press_lrc(GtkWidget *widget,GdkEventButton *event,gpointer data) {
    if (event->button==1) {
        gtk_window_begin_move_drag(GTK_WINDOW(lrc_window),event->button,event->x_root,event->y_root,event->time);
    } else {
        gvoid on_tray_menu_event();
        on_tray_menu_event();
    }
}
gvoid leave_lrc() {
    gtk_window_get_position( (GtkWindow *)lrc_window,&lrc_x,&lrc_y);
}
gvoid set_input_shape_mask () {/**///鼠标穿透
    gint w, h;
    gdk_drawable_get_size (lrc_window->window, &w, &h);
    GdkPixmap *input_mask = gdk_pixmap_new (NULL, w, h, 1);
    GdkGC *gc = gdk_gc_new (input_mask);
    GdkColor color;
    color.pixel = 0;              /* black */
    gdk_gc_set_foreground (gc, &color);
    gdk_draw_rectangle (input_mask, gc, TRUE, 0, 0, w, h);
    gtk_widget_input_shape_combine_mask (lrc_window, input_mask, 0, 0);
    g_object_unref (input_mask);
    g_object_unref (gc);
}
gboolean on_window_expose_event(GtkWidget * widget, GdkEventExpose * event, gpointer data) {
    cairo_t *cr;
    cr = gdk_cairo_create(widget->window);
    cairo_set_source_rgba (cr, 0.0, 0.0, 0.0, 0.0);
    cairo_set_source_surface(cr, lrc_image, 0, 0);

    cairo_set_operator(cr, CAIRO_OPERATOR_SOURCE);
    cairo_paint(cr);
    cairo_destroy(cr);

    gtk_window_move((GtkWindow *)lrc_window,lrc_x,lrc_y);
    return FALSE;
}
gvoid close_lrc() {
    if (GTK_IS_WINDOW(lrc_window)) {
        gtk_widget_destroy(lrc_window);
    }
    lrc_window = 0;
}
gboolean lrc_show (gchar lrc[2000]) {/**///画公仔的
    static gchar lrc2[2000];
    gchar lrc3[2000];
    strcpy(lrc3,lrc);

    if (lrc[0]=='0'&&lrc[1]=='9') {
        if (lrc2[0] == 0)strcpy(lrc3,"");
        strcpy(lrc3,lrc2);
    } else {
        strcpy(lrc2,lrc);
    }
    if (!lrc_window) {
        gchar lrc_image_path[2000];
        FILE *lrc_image_file;
        if (lrc_back_png!=NULL&&save_desktop_lrc_back_png) {
            strcpy(lrc_image_path ,lrc_back_png);
            lrc_image_file= fopen(lrc_image_path,"r");
        } else {
            lrc_image_file =0 ;
        }

        if (lrc_image_file) {
            lrc_image = cairo_image_surface_create_from_png(lrc_image_path);
            fclose(lrc_image_file);
            lrc_image_path[0] =0;
        } else {
            lrc_image = cairo_image_surface_create( CAIRO_FORMAT_ARGB32, 0, 0);
        }
        lrc_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_window_set_keep_above     (GTK_WINDOW (lrc_window),TRUE);
        gtk_window_set_skip_taskbar_hint(GTK_WINDOW(lrc_window),TRUE);
        gtk_window_stick (GTK_WINDOW(lrc_window));
        gtk_window_set_decorated(GTK_WINDOW(lrc_window), FALSE);
        gtk_window_move((GtkWindow *)lrc_window,lrc_x,lrc_y);
        gtk_widget_set_app_paintable(lrc_window, TRUE);

        lrc_fixed = gtk_fixed_new();
        gtk_widget_show(lrc_fixed);
        gtk_container_add((GtkContainer *)lrc_window,( GtkWidget       *)lrc_fixed);
        lrc_label2 = gtk_label_new(lrc);
        gtk_widget_show(lrc_label2);
        gtk_fixed_put( (GtkFixed  *)lrc_fixed,lrc_label2,1,1);

        GtkWidget * lrc_eventbox=gtk_event_box_new();
        gtk_event_box_set_visible_window( (GtkEventBox *)lrc_eventbox,FALSE);
        gtk_widget_show(lrc_eventbox);
        gtk_fixed_put( (GtkFixed  *)lrc_fixed,lrc_eventbox,0,0);

        lrc_label = gtk_label_new(lrc3);
        gtk_widget_show(lrc_label);
        gtk_container_add((GtkContainer *)lrc_eventbox,( GtkWidget       *)lrc_label);

        lrc_screen = gtk_widget_get_screen(lrc_window);
        lrc_colormap = gdk_screen_get_rgba_colormap(lrc_screen);
        gtk_widget_set_colormap(lrc_window, lrc_colormap);
        g_signal_connect(G_OBJECT(lrc_window), "expose-event",G_CALLBACK(on_window_expose_event), NULL);
        g_signal_connect(G_OBJECT(lrc_window), "delete-event",G_CALLBACK(close_lrc), NULL);
        g_signal_connect(G_OBJECT(lrc_eventbox), "button_press_event",G_CALLBACK(press_lrc), NULL);
        g_signal_connect(G_OBJECT(lrc_window), "leave-notify-event",G_CALLBACK(leave_lrc), NULL);
        gtk_widget_show_all(lrc_window);
        gtk_window_move((GtkWindow *)lrc_window,lrc_x,lrc_y);
    }
    PangoFontDescription *pfd;
    pfd = pango_font_description_from_string(font_lrc);
    gtk_widget_modify_font(GTK_WIDGET(lrc_label),pfd);
    gtk_widget_modify_font(GTK_WIDGET(lrc_label2),pfd);
    pango_font_description_free(pfd);
    gtk_label_set_text((GtkLabel *)lrc_label,"");
    gtk_label_set_text((GtkLabel *)lrc_label2,"");
    gtk_label_set_markup ((GtkLabel  *)lrc_label, g_markup_printf_escaped ("<span  foreground='#%s'>%s</span>",lrc_color_front,lrc3));
    gtk_label_set_markup ((GtkLabel  *)lrc_label2, g_markup_printf_escaped ("<span  foreground='#%s'>%s</span>",lrc_color_back,lrc3));

    if (save_lrc_no_has_press_event)set_input_shape_mask();
    gtk_window_resize((GtkWindow   *)lrc_window,1,1);
    gtk_window_move((GtkWindow *)lrc_window,lrc_x,lrc_y);
    return FALSE;
}
gvoid change_lrc_has_press_event() {
    save_lrc_no_has_press_event=!save_lrc_no_has_press_event;
    close_lrc();
    lrc_show("09");
}
gvoid lrc_run() {/**///解析并提交显示
    if (!show_lrc) {
        close_lrc();
        return;
    }
    gchar A[60];
    g_snprintf(A,60,"%02u[%02u:%02u.%02u]",GST_TIME_ARGS(pos));
    gint n=0;
    while (n!= 12) {
        A[n] = A[n+2];
        n++;
    }
    A[n-1]= '\0';
    if ( (strncmp(A,line[line_number],9)>=0&&strncmp(A,line[line_number+1],9)<0)|| (line[line_number][0]!=0&&strncmp(A,line[line_number],9)>=0&&line[line_number+1][0]==0) ) {
        gchar tmp[2000];
        n=0;
        while (line[line_number][n+9]) {
            tmp[n]= line[line_number][n+10];
            n++;
        }
        lrc_show(tmp);
        line_number++;
    } else {
        if (strncmp(A,line[line_number],9)>=0&&line[line_number+1][0]!=0&&strncmp(A,line[line_number+1],9)>=0) {
            while (strncmp(A,line[line_number],9)>=0&&strncmp(A,line[line_number+1],9)>=0) {
                line_number++;
                if (strncmp(A,line[line_number],9)>=0&&strncmp(A,line[line_number+1],9)<0) {
                    return ;
                }
                if (line[line_number][0]==0) {
                    line_number = 0;
                    return ;
                }
            }
        } else {
            if (line_number-2>=0&&strncmp(A,line[line_number-2],9)<0&&strncmp(A,line[line_number],9)<0) {
                while (strncmp(A,line[line_number],9)<0) {
                    line_number--;
                    if (line_number<0 ) {
                        line_number = 0;
                        break;
                    }
                }
            }
        }
    }
    return ;
}
gvoid on_downloader_button_search_clicked  (GtkButton *button,GtkWidget *iceplayer_lrc_downloader) {
    gvoid choose_lrc_to_download();
    strcpy(keyword,gtk_entry_get_text((GtkEntry *)iceplayer_lrc_downloader_entry));
    lrc_show("搜索歌词...");
    choose_lrc_to_download();
}
gvoid on_downloader_list_selection_changed (GtkList *list,GtkWidget *iceplayer_lrc_downloader) {
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(iceplayer_lrc_downloader_list));
    GList *glist = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(gtk_tree_view_get_selection(GTK_TREE_VIEW(iceplayer_lrc_downloader_list))),&model);
    if (glist)download_choose_number = atoi(gtk_tree_path_to_string(glist->data));
}
gvoid on_downloader_button_close_clicked (GtkButton *button,GtkWidget *iceplayer_lrc_downloader) {
    gtk_widget_destroy(iceplayer_lrc_downloader);
    download_choose_number = 0 ;
    gboolean lrc_to_line();
    lrc_to_line();
    unlink("/tmp/iceplayer_lrc_tmp");
}
gvoid on_downloader_button_lrc123_enter (GtkButton *button,GtkWidget *iceplayer_lrc_downloader) {
    gtk_widget_destroy(iceplayer_lrc_downloader);
    if (system("firefox www.lrc123.com"));
    download_choose_number = -1 ;
}
gboolean lrc_to_line() {
    gchar lrc_path[2000];
    if (save_download_lrc_path) {
        gint n=0;
        while (uri[n+7]) {
            lrc_path[n]=uri[n+7];
            n++;
        }
        lrc_path[n]='\0';
        while (lrc_path[n]!='.'|| n==0)
            n--;
        lrc_path[++n]='\0';
        strcat(lrc_path,"lrc");
    } else {
        if (download_lrc_path[0]) {
            strcpy(lrc_path,download_lrc_path);
            strcat(lrc_path,"/");
            strcat(lrc_path,play_name);
            gint n = strlen(lrc_path);
            while (lrc_path[n]!='.'|| n==0)
                n--;
            lrc_path[++n]='\0';
            strcat(lrc_path,"lrc");
        }
    }
    FILE* lrc_file = fopen(lrc_path,"r");
    if (lrc_file) {
        gchar tmp[2000];
        gint n=0,m=0;
///*歌词解析模块开始～～*/
///*检验是否繁体*/
        gchar is_J_F[200];
        gboolean is_F = FALSE;
        if (system("echo $LANG > /tmp/iceplayer_tmp"));
        FILE * file_J_F = fopen("/tmp/iceplayer_tmp","r");
        if (file_J_F)if (fgets(is_J_F,200,file_J_F));
        if (file_J_F)fclose(file_J_F);
        unlink("/tmp/iceplayer_tmp");
        if (strstr(is_J_F,"zh_HK")||strstr(is_J_F,"zh_TW")||strstr(is_J_F,"en_")) {
            is_F = TRUE;
        }
        /**/
        if (!fgets(tmp,2000,lrc_file)) {
            fclose(lrc_file);
            return TRUE;
        }
        rewind(lrc_file);
        while (fgets(tmp,2000,lrc_file)) {
            gchar *str = convert(tmp,is_F);
            while (str==NULL||strlen(tmp)==2) {
                tmp[strlen(tmp)-2]=32;
                tmp[strlen(tmp)-1]=0;
                str = convert(tmp,is_F);
            }
            if (str == NULL) {
                str = convert(tmp,!is_F);
                if (str != NULL) {
                    strcpy(lrc_line,str);
                    is_F = !is_F;///*莫非机器上的语言设置出毛病了？*/
                } else {
                    continue ;///*最后的希望都没了，莫非歌词来源有问题？*/
                }
            } else {
                strcpy(lrc_line,str);
            }
            gint n=0;
            while (lrc_line[n]) {
                if (lrc_line[n] == '\n')
                    lrc_line[n] = ' ';
                n++;
            }

            if (lrc_line[0]=='[') {
                switch (lrc_line[1]) {
                case 't': {
                    n=0;
                    while (lrc_line[n+4]!=']'&&n+4<=strlen(lrc_line)) {
                        ti[n]=lrc_line[n+4];
                        n++;
                    }
                    ti[n]='\0';
                    break;
                }
                case 'a': {
                    n=0;
                    if (lrc_line[2] == 'r') {
                        while (lrc_line[n+4]!=']'&&n+4<=strlen(lrc_line)) {
                            ar[n]=lrc_line[n+4];
                            n++;
                        }
                        ar[n]='\0';
                    } else {
                        while (lrc_line[n+4]!=']'&&n+4<=strlen(lrc_line)) {
                            al[n]=lrc_line[n+4];
                            n++;
                        }
                        al[n]='\0';
                    }
                    break;
                }
                case 'b': {
                    n=0;
                    while (lrc_line[n+4]!=']'&&n+4<=strlen(lrc_line)) {
                        by[n]=lrc_line[n+4];
                        n++;
                    }
                    by[n]='\0';
                    break;
                }
                case 'o': {
                    n=0;
                    while (lrc_line[n+8]!=']'&&n+4<=strlen(lrc_line)) {
                        offset[n]=lrc_line[n+8];
                        n++;
                    }
                    offset[n]='\0';
                    offset_set = atoi(offset);
                    break;
                }
                default: {
                    gint k=0;
                    if (lrc_line[0]=='['&&lrc_line[3] ==':'&&lrc_line[6]=='.'&&lrc_line[9]==']') {///**？/
                        gint lrc_line_number = strlen(lrc_line);
                        gchar tmp[2000];
                        while (lrc_line[lrc_line_number-9]!='[') {
                            if (lrc_line[lrc_line_number]==13)lrc_line[lrc_line_number]='\0';
                            lrc_line_number--;
                        }
                        lrc_line_number++;
                        gint s = 0;
                        while (lrc_line[lrc_line_number]) {
                            tmp[s++]=lrc_line[lrc_line_number++];
                        }
                        tmp[s]='\0';
                        while (lrc_line[k*10]=='['&&lrc_line[k*10+9]==']') {
                            n=k*10;
                            s = 0;
                            while (n!=k*10+10) {
                                line[m][s++] = lrc_line[n++];
                            }
                            line[m][s]='\0';
                            strcat(line[m],tmp);
                            m++;
                            k++;
                        }
                    }
                    if (lrc_line[0]=='['&&lrc_line[3] ==':'&&lrc_line[6]==']') {///*不解释*/
                        gint lrc_line_number = strlen(lrc_line);
                        gchar tmp[2000];
                        while (lrc_line[lrc_line_number-6]!='[') {
                            if (lrc_line[lrc_line_number]==13)lrc_line[lrc_line_number]='\0';
                            lrc_line_number--;
                        }
                        lrc_line_number--;
                        lrc_line_number--;
                        gint s = 0;
                        while (lrc_line[lrc_line_number]) {
                            tmp[s++]=lrc_line[lrc_line_number++];
                        }
                        tmp[s]='\0';
                        while (lrc_line[k*7]=='['&&lrc_line[k*7+6]==']') {
                            n=k*7;
                            s = 0;
                            while (s!=7) {
                                line[m][s++] = lrc_line[n++];
                            }
                            line[m][7]='\0';
                            strcat(line[m],tmp);
                            m++;
                            k++;
                        }
                    }
                }
                }
            }
        }
        if (lrc_file)fclose(lrc_file);
        gint b=0;

        if (line[0][0]) {///*冒泡排序*/
            for (n=0;n<m-1;n++) {
                for (b=0;b<m-n-1;b++) {
                    if (strcmp(line[b],line[b+1])==1) {
                        gchar tmp[2000];
                        strcpy(tmp,line[b]);
                        strcpy(line[b],line[b+1]);
                        strcpy(line[b+1],tmp);

                    }
                }
            }
        }
        return FALSE;
    }
    return TRUE;
}
gvoid on_downloader_button_download_clicked  (GtkButton *button,GtkWidget *iceplayer_lrc_downloader) {
    if (download_info[download_choose_number].download_uri[0]) {
        gtk_widget_destroy(iceplayer_lrc_downloader);

        gchar lrc_path[2000];
        if (save_download_lrc_path) {
            gint n=0;
            while (uri[n+7]) {
                lrc_path[n]=uri[n+7];
                n++;
            }
            lrc_path[n]='\0';
            while (lrc_path[n]!='.'|| n==0)
                n--;
            lrc_path[++n]='\0';
            strcat(lrc_path,"lrc");
        } else {
            if (download_lrc_path[0]) {
                strcpy(lrc_path,download_lrc_path);
                strcat(lrc_path,"/");
                strcat(lrc_path,play_name);
                gint n = strlen(lrc_path);
                while (lrc_path[n]!='.'|| n==0)
                    n--;
                lrc_path[++n]='\0';
                strcat(lrc_path,"lrc");
            }
        }

        gchar wget[2000];
        strcpy(wget,"wget \"");
        strcat(wget,download_info[download_choose_number].download_uri);
        strcat(wget,"\" -O \"");
        strcat(wget,lrc_path);
        strcat(wget,"\"");

        g_thread_create((GThreadFunc)system,wget,FALSE,NULL);
        lrc_show("下载歌词...");
        g_timeout_add(1000,(GSourceFunc)lrc_to_line,NULL);
    }
}
gboolean on_downloader_list_key_press (GtkWidget *iceplayer_lrc_downloader_list,GdkEventKey *event,GtkWidget *iceplayer_lrc_downloader) {
    if (event->type == GDK_KEY_PRESS) {
        if (event->keyval==GDK_Return) {
            on_downloader_button_download_clicked(NULL,iceplayer_lrc_downloader);
        }
    }
    return FALSE;
}
gboolean on_downloader_entry_key_press (GtkWidget *iceplayer_lrc_downloader_entry,GdkEventKey *event,GtkWidget *iceplayer_lrc_downloader) {
    if (event->type == GDK_KEY_PRESS) {
        if (event->keyval==GDK_Return) {
            on_downloader_button_search_clicked(NULL,iceplayer_lrc_downloader);
        }
    }
    return FALSE;
}
gvoid w3m() {
    gchar w3m[2000];
    FILE *file = fopen("/tmp/iceplayer_lrc_download_tmp","r");
    if (file) {
        if (fgets(w3m,2000,file));
        fclose(file);
        unlink("/tmp/iceplayer_lrc_download_tmp");
        if (system(w3m));
        FILE* file = fopen("/tmp/iceplayer_lrc_tmp","r");
        if (file) {
            fclose(file);
            gchar lrc[2000];
            FILE *lrc_tmp_file = fopen("/tmp/iceplayer_lrc_tmp","r");
            if ( fgets(lrc,2000,lrc_tmp_file)) {};
            if (!lrc[0]) {
                if (lrc_tmp_file)fclose(lrc_tmp_file);
                if (system(w3m));
            }
        } else {
            if (system(w3m));
        }
    }
}
gboolean uri_to_lrc() {
    static int num =0;
    num++;

    FILE* file = fopen("/tmp/iceplayer_lrc_tmp","r");
    if (file) {
        fclose(file);
        gchar lrc[2000];
        gint a;
        FILE *lrc_tmp_file = fopen("/tmp/iceplayer_lrc_tmp","r");
        if ( fgets(lrc,2000,lrc_tmp_file)) {};
        if (!lrc[0]) {
            if (lrc_tmp_file)fclose(lrc_tmp_file);
            unlink("/tmp/iceplayer_lrc_tmp");
            gchar sy_w3m[2000];
            strcpy(sy_w3m,"w3m \"www.lrc123.com/?keyword=");
            strcat(sy_w3m,keyword);
            strcat(sy_w3m,"&field=all\" > /tmp/iceplayer_lrc_tmp");

            FILE *file = fopen("/tmp/iceplayer_lrc_download_tmp","w");
            fputs(sy_w3m,file);
            fclose(file);

            g_thread_create((GThreadFunc)w3m,NULL,FALSE,NULL);
            return TRUE;
        }

        while (!strstr(lrc,"LRC123歌词结果")) {
            if ( !fgets(lrc,2000,lrc_tmp_file)) {
                fclose(lrc_tmp_file);
                unlink("/tmp/iceplayer_lrc_tmp");
                gchar sy_w3m[2000];
                strcpy(sy_w3m,"w3m \"www.lrc123.com/?keyword=");
                strcat(sy_w3m,keyword);
                strcat(sy_w3m,"&field=all\" > /tmp/iceplayer_lrc_tmp");

                FILE *file = fopen("/tmp/iceplayer_lrc_download_tmp","w");
                fputs(sy_w3m,file);
                fclose(file);

                g_thread_create((GThreadFunc)w3m,NULL,FALSE,NULL);
                return TRUE;
            }
        }
        if ( fscanf(lrc_tmp_file,"共%d个",&a));
        if (a) {
            download_choose_number = 0;
            while (fgets(lrc,2000,lrc_tmp_file )) {
                if (strstr(lrc,"歌手:")) {
                    lrc[strlen(lrc)-1]='\0';
                    strcpy( download_info[download_choose_number].editor  ,lrc);
                    continue ;
                }
                if (strstr(lrc,"专辑:")) {
                    lrc[strlen(lrc)-1]='\0';
                    strcpy( download_info[download_choose_number].album  ,lrc);
                    continue ;
                }
                if (strstr(lrc,"歌曲:")) {
                    lrc[strlen(lrc)-1]='\0';
                    strcpy( download_info[download_choose_number].title  ,lrc);
                    continue ;
                }
                if (strstr(lrc,"http://www.lrc123.com/download/lrc/")) {
                    gint n = strlen(lrc)-3;
                    while (1) {
                        if(n==0||(lrc[n] == 'a'&&lrc[n+1] == 's'&&lrc[n+2] == 'p'&&lrc[n+3] == 'x'))break;
                        n--;
                    }
                    if (n!=0)lrc[n+4]=0;

                    strcpy( download_info[download_choose_number].download_uri,lrc);
                    download_choose_number++;
                }
                if (download_choose_number == 20)break;
            }
            download_choose_number -- ;
            if (download_info == NULL) {
                return FALSE;
            }
        }

        if (lrc_tmp_file) {
            fclose(lrc_tmp_file);
        }
        unlink("/tmp/iceplayer_lrc_tmp");
        if (GTK_IS_WIDGET(iceplayer_lrc_downloader))gtk_widget_destroy(iceplayer_lrc_downloader);

        GtkWidget *iceplayer_lrc_downloader_table;
        GtkWidget *iceplayer_lrc_downloader_button_search;
        GtkWidget *iceplayer_lrc_downloader_scrolledwindow;
        GtkTreeSelection *iceplayer_lrc_downloader_selection;
        GtkWidget *iceplayer_lrc_downloader_vbox;
        GtkWidget *iceplayer_lrc_downloader_button_download;
        GtkWidget *iceplayer_lrc_downloader_button_close;
        GtkWidget *iceplayer_lrc_downloader_button_lrc123;

        iceplayer_lrc_downloader = gtk_dialog_new();
        gtk_widget_set_size_request (iceplayer_lrc_downloader, 350, 250);
        gtk_container_set_border_width (GTK_CONTAINER (iceplayer_lrc_downloader), 5);
        gtk_window_set_title (GTK_WINDOW (iceplayer_lrc_downloader), "iceplayer lrc downloader");
        gtk_window_set_type_hint (GTK_WINDOW (iceplayer_lrc_downloader), GDK_WINDOW_TYPE_HINT_DIALOG);
        gtk_window_set_keep_above     (GTK_WINDOW (iceplayer_lrc_downloader),TRUE);

        iceplayer_lrc_downloader_table = gtk_table_new (2, 2, FALSE);
        gtk_widget_show (iceplayer_lrc_downloader_table);
        gtk_box_pack_start (GTK_BOX (((GtkDialog *)iceplayer_lrc_downloader)->vbox), iceplayer_lrc_downloader_table, TRUE, TRUE, 0);

        iceplayer_lrc_downloader_entry = gtk_entry_new();
        gtk_entry_set_text ((GtkEntry *)iceplayer_lrc_downloader_entry,keyword);
        gtk_widget_show (iceplayer_lrc_downloader_entry);

        gtk_table_attach (GTK_TABLE (iceplayer_lrc_downloader_table), iceplayer_lrc_downloader_entry, 0, 1, 0, 1,(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),(GtkAttachOptions) (0), 0, 0);
        gtk_entry_set_invisible_char (GTK_ENTRY (iceplayer_lrc_downloader_entry), 9679);
        gtk_entry_set_activates_default (GTK_ENTRY (iceplayer_lrc_downloader_entry), TRUE);

        iceplayer_lrc_downloader_button_search = gtk_button_new_with_mnemonic ("搜索");
        gtk_widget_show (iceplayer_lrc_downloader_button_search);
        gtk_table_attach (GTK_TABLE (iceplayer_lrc_downloader_table), iceplayer_lrc_downloader_button_search, 1, 2, 0, 1,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);

        iceplayer_lrc_downloader_scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
        gtk_widget_show (iceplayer_lrc_downloader_scrolledwindow);
        gtk_table_attach (GTK_TABLE (iceplayer_lrc_downloader_table), iceplayer_lrc_downloader_scrolledwindow, 0, 1, 1, 2,(GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
        gtk_container_set_border_width (GTK_CONTAINER (iceplayer_lrc_downloader_scrolledwindow), 1);
        gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (iceplayer_lrc_downloader_scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
        gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (iceplayer_lrc_downloader_scrolledwindow), GTK_SHADOW_IN);

        iceplayer_lrc_downloader_list = gtk_tree_view_new();
        gtk_widget_show(iceplayer_lrc_downloader_list);
        gtk_container_add(GTK_CONTAINER(iceplayer_lrc_downloader_scrolledwindow),iceplayer_lrc_downloader_list);
        gtk_tree_view_set_reorderable(GTK_TREE_VIEW(iceplayer_lrc_downloader_list), TRUE);
        gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(iceplayer_lrc_downloader_list), FALSE);

        GtkCellRenderer *renderer;
        GtkListStore *store;
        renderer = gtk_cell_renderer_text_new();
        gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(iceplayer_lrc_downloader_list), 0, " ", renderer, "text", 0, NULL);
        gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(iceplayer_lrc_downloader_list), 0, " ", renderer, "text", 1, NULL);
        gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(iceplayer_lrc_downloader_list), 0, " ", renderer, "text", 2, NULL);
        store = gtk_list_store_new(3, G_TYPE_STRING, G_TYPE_STRING,G_TYPE_STRING);
        gtk_tree_view_set_model(GTK_TREE_VIEW(iceplayer_lrc_downloader_list),GTK_TREE_MODEL(store));
        g_object_unref(store);

        iceplayer_lrc_downloader_selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(iceplayer_lrc_downloader_list));
        gtk_tree_selection_set_mode(iceplayer_lrc_downloader_selection,GTK_SELECTION_SINGLE);

        iceplayer_lrc_downloader_vbox = gtk_vbox_new (FALSE, 0);
        gtk_widget_show (iceplayer_lrc_downloader_vbox);
        gtk_table_attach (GTK_TABLE (iceplayer_lrc_downloader_table), iceplayer_lrc_downloader_vbox, 1, 2, 1, 2,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (GTK_FILL), 0, 0);

        iceplayer_lrc_downloader_button_download = gtk_button_new_with_mnemonic ("下载");
        gtk_widget_show (iceplayer_lrc_downloader_button_download);
        gtk_box_pack_start (GTK_BOX (iceplayer_lrc_downloader_vbox), iceplayer_lrc_downloader_button_download, FALSE, FALSE, 0);

        iceplayer_lrc_downloader_button_close = gtk_button_new_with_mnemonic ("关闭");
        gtk_widget_show (iceplayer_lrc_downloader_button_close);
        gtk_box_pack_start (GTK_BOX (iceplayer_lrc_downloader_vbox), iceplayer_lrc_downloader_button_close, FALSE, FALSE, 0);

        iceplayer_lrc_downloader_button_lrc123 = gtk_button_new_with_mnemonic ("lrc123.com");
        gtk_widget_show (iceplayer_lrc_downloader_button_lrc123);
        gtk_box_pack_end (GTK_BOX (iceplayer_lrc_downloader_vbox), iceplayer_lrc_downloader_button_lrc123, FALSE, FALSE, 0);
        gtk_button_set_relief (GTK_BUTTON (iceplayer_lrc_downloader_button_lrc123), GTK_RELIEF_NONE);

        g_signal_connect ((gpointer) iceplayer_lrc_downloader_button_search,"clicked",G_CALLBACK (on_downloader_button_search_clicked),iceplayer_lrc_downloader);
        g_signal_connect ((gpointer) iceplayer_lrc_downloader_button_download,"clicked",G_CALLBACK (on_downloader_button_download_clicked),iceplayer_lrc_downloader);
        g_signal_connect ((gpointer) iceplayer_lrc_downloader_button_close,"clicked",G_CALLBACK (on_downloader_button_close_clicked),iceplayer_lrc_downloader);
        g_signal_connect ((gpointer) iceplayer_lrc_downloader_button_lrc123,"clicked",G_CALLBACK (on_downloader_button_lrc123_enter),iceplayer_lrc_downloader);
        g_signal_connect ((gpointer) iceplayer_lrc_downloader_list,"cursor_changed",G_CALLBACK (on_downloader_list_selection_changed),iceplayer_lrc_downloader);
        g_signal_connect ((gpointer) iceplayer_lrc_downloader_list,"key_press_event",G_CALLBACK (on_downloader_list_key_press),iceplayer_lrc_downloader);
        g_signal_connect ((gpointer) iceplayer_lrc_downloader_entry,"key_press_event",G_CALLBACK (on_downloader_entry_key_press),iceplayer_lrc_downloader);
        GtkTreeIter iter;
        store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(iceplayer_lrc_downloader_list)));
        gtk_list_store_clear(store);
        if (a) {
            download_choose_number = 0;
            while (download_info[download_choose_number].download_uri[0]) {
                store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(iceplayer_lrc_downloader_list)));
                gtk_list_store_append(store, &iter);
                gtk_list_store_set(store, &iter,0,download_info[download_choose_number].album,1,download_info[download_choose_number].editor,2, download_info[download_choose_number].title,-1);
                download_choose_number ++ ;
            }
            gtk_tree_view_set_cursor((GtkTreeView *) iceplayer_lrc_downloader_list,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) iceplayer_lrc_downloader_list,0),FALSE);
        }
        gtk_dialog_run((GtkDialog *)iceplayer_lrc_downloader);
        close_lrc();
        return FALSE;
    }

    if (num == 9) {
        lrc_show("网络链接失败或连接出错！");
        return TRUE;
    }
    if (num == 10) {
        close_lrc();
        num = 0;
        unlink("/tmp/iceplayer_lrc_tmp");
        return FALSE;
    }

    return TRUE;
}
gvoid choose_lrc_to_download() {
    gchar sy_w3m[2000];
    strcpy(sy_w3m,"w3m \"www.lrc123.com/?keyword=");
    strcat(sy_w3m,keyword);
    strcat(sy_w3m,"&field=all\" > /tmp/iceplayer_lrc_tmp");

    FILE *file = fopen("/tmp/iceplayer_lrc_download_tmp","w");
    fputs(sy_w3m,file);
    fclose(file);

    g_thread_create((GThreadFunc)w3m,NULL,FALSE,NULL);
    gint sd=0;
    while (sd<=20) {
        download_info[sd].album[0]=0;
        download_info[sd].download_uri[0]=0;
        download_info[sd].editor[0]=0;
        download_info[sd++].title[0]=0;
    }

    if (GTK_IS_WIDGET(iceplayer_lrc_downloader))gtk_widget_destroy(iceplayer_lrc_downloader);

    g_timeout_add(3000,(GSourceFunc)uri_to_lrc,NULL);
}
gvoid lrc_redownload() {
    if (!save_download_lrc||!show_lrc) {
        GtkWidget *dialog_real = gtk_message_dialog_new(NULL,GTK_DIALOG_DESTROY_WITH_PARENT    ,GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK,"iceplayer  \n 歌词下载功能 或 歌词功能 关闭");
        gtk_dialog_run((GtkDialog *)dialog_real);
        gtk_widget_destroy(dialog_real);
        return;
    }
    show_lrc = TRUE;
    if (!uri[0])
        play();
    if (uri[0]) {
        close_lrc() ;
        gint n=0;
        while (line[n][0])line[n++][0] = 0;
        n=0;
        line_number = 0;
        gchar lrc_path[2000];
        if (save_download_lrc_path) {
            gint n=0;
            while (uri[n+7]) {
                lrc_path[n]=uri[n+7];
                n++;
            }
            lrc_path[n]='\0';
            while (lrc_path[n]!='.'|| n==0)
                n--;
            lrc_path[++n]='\0';
            strcat(lrc_path,"lrc");
        } else {
            if (download_lrc_path[0]) {
                strcpy(lrc_path,download_lrc_path);
                strcat(lrc_path,"/");
                strcat(lrc_path,play_name);
                gint n = strlen(lrc_path);
                while (lrc_path[n]!='.'|| n==0)
                    n--;
                lrc_path[++n]='\0';
                strcat(lrc_path,"lrc");
            }
        }

        unlink("/tmp/iceplayer_lrc_tmp");
        gint sa,sb ;
        sa=sb =strlen(lrc_path);
        gint sd =0;
        while (lrc_path[sa]!='/'||sa==0)
            sa --;
        sa++;
        while (sa<sb) {
            if (lrc_path[sa]==-17&&lrc_path[sa+1]==-68&&lrc_path[sa+2]==-115) {
                keyword[sd] = ' ';
                sa=sa+3;
                sd++;
                if (lrc_path[sa]=='.')break;
                continue ;
            }
            if (lrc_path[sa]=='-'||lrc_path[sa]=='_'||lrc_path[sa]=='{'||lrc_path[sa]=='}'||lrc_path[sa]=='('||lrc_path[sa]==')'||lrc_path[sa]=='['||lrc_path[sa]==']'||lrc_path[sa]=='\\'||lrc_path[sa]=='/'||lrc_path[sa]=='<'||lrc_path[sa]=='>') {
                keyword[sd] = ' ';
            } else {
                keyword[sd] = lrc_path[sa];
            }
            sa++;
            sd++;
            if (lrc_path[sa]=='.')break;
        }
        keyword[sd] = '\0';///*大多数ID3都有乱码，还是优先用文件名*/
        lrc_show("搜索歌词...");
        choose_lrc_to_download();
        unlink("/tmp/iceplayer_lrc_tmp");
    }
}
gvoid lrc() {
    close_lrc() ;
    gint n=0;
    while (line[n][0])line[n++][0] = 0;
    n=0;
    line_number = 0;
    gchar lrc_path[2000];
    if (save_download_lrc_path) {
        gint n=0;
        while (uri[n+7]) {
            lrc_path[n]=uri[n+7];
            n++;
        }
        lrc_path[n]='\0';
        while (lrc_path[n]!='.'|| n==0)
            n--;
        lrc_path[++n]='\0';
        strcat(lrc_path,"lrc");
    } else {
        if (download_lrc_path[0]) {
            strcpy(lrc_path,download_lrc_path);
            strcat(lrc_path,"/");
            strcat(lrc_path,play_name);
            gint n = strlen(lrc_path);
            while (lrc_path[n]!='.'|| n==0)
                n--;
            lrc_path[++n]='\0';
            strcat(lrc_path,"lrc");
        }
    }
    FILE *lrc_file = fopen(lrc_path,"r");
    if (!lrc_file&&save_download_lrc) {///*没有歌词？那就下载吧*/
        unlink("/tmp/iceplayer_lrc_tmp");
        gint sa,sb ;
        sa=sb =strlen(lrc_path);
        gint sd =0;
        while (lrc_path[sa]!='/'||sa==0)
            sa --;
        sa++;
        while (sa<sb) {
            if (lrc_path[sa]==-17&&lrc_path[sa+1]==-68&&lrc_path[sa+2]==-115) {
                keyword[sd] = ' ';
                sa=sa+3;
                sd++;
                if (lrc_path[sa]=='.')break;
                continue ;
            }
            if (lrc_path[sa]=='-'||lrc_path[sa]=='_'||lrc_path[sa]=='{'||lrc_path[sa]=='}'||lrc_path[sa]=='('||lrc_path[sa]==')'||lrc_path[sa]=='['||lrc_path[sa]==']'||lrc_path[sa]=='\\'||lrc_path[sa]=='/') {
                keyword[sd] = ' ';
            } else {
                keyword[sd] = lrc_path[sa];
            }
            sa++;
            sd++;
            if (lrc_path[sa]=='.')break;
        }
        keyword[sd] = '\0';///*大多数ID3都有乱码，还是优先用文件名*/
        lrc_show("搜索歌词...");
        choose_lrc_to_download();
        unlink("/tmp/iceplayer_lrc_tmp");
    }
    if (lrc_file)fclose(lrc_file);
    lrc_to_line();
}
